
#include <Wire.h>
#include "MP1246.h"

static byte MP1246_VALUES [6] = {0x1F, 0x00, 0x00, 0x00, 0x00, 0x00};


MP1246::MP1246()
{

}

//------------------------------------------------------------------------------
// PUBLIC FUNCTIONS
//------------------------------------------------------------------------------
void MP1246::Init ()
{
   Wire.beginTransmission(MP1246_ADDRESS);
   Wire.write (MP1246_VALUES [0]);
   for (int i=1; i<6; i++)
     Wire.write (((0x08+(i-1))<<4) | MP1246_VALUES [i]);
   Wire.endTransmission();
}
//------------------------------------------------------------------------------
void MP1246::SetVolume (byte Volume)
{
   if (Volume <= 0x2F)
   {
     MP1246_VALUES [0] = Volume;
     Write (Volume);
   }
}
//------------------------------------------------------------------------------
void MP1246::SetBand (byte Band, byte Value)
{
   if (((Band >= 1) && (Band <= 5)) && (Value <= 0x0F))
   {
     MP1246_VALUES[Band] = Value;           
     Write (((0x08+(Band-1))<<4) | Value);    
   }
}
//------------------------------------------------------------------------------
byte MP1246::GetVolume ()
{
   return (MP1246_VALUES [0]);
}
//------------------------------------------------------------------------------
byte MP1246::GetBandValue (byte Band)
{
   return (MP1246_VALUES [Band]);
}
//------------------------------------------------------------------------------
// PRIVATE FUNCTIONS
//------------------------------------------------------------------------------
void MP1246::Write (byte Value)
{
   Wire.beginTransmission(MP1246_ADDRESS);
   Wire.write (Value);
   Wire.endTransmission();
}


MP1246 MP1246_EQUALIZER = MP1246 ();
